#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>

char **file_entries;
int nombre;

void scan_file (char *fichier)
{
  FILE *fichfd; 
  char string[256];
  file_entries = (char**) malloc(sizeof(char *) * 512);
  nombre = 0;

  fichfd = fopen (fichier, "r");

  while (fgets (string, 256, fichfd))
  {
    file_entries[nombre] = (char*) malloc((1 + strlen(string)) * sizeof(char));
	strncpy(file_entries[nombre], string, strlen(string));
	nombre ++;
  }

  fclose (fichfd);
}

unsigned char get_random()
{
  unsigned char n;
  int fd = open("/dev/random", O_RDONLY);
  read (fd, (char*)&n, 1);
  close (fd);
  return (n);
}

int main (int argn, char **argv)
{
  int fd, fdc, len;
  unsigned char l;
  struct sockaddr_in s_in;

  fd = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP);

  s_in.sin_port = htons(8039);
  s_in.sin_family = AF_INET;
  s_in.sin_addr.s_addr = INADDR_ANY;

  scan_file("./excuses");

  if(bind (fd, (struct sockaddr *)&s_in, sizeof(struct sockaddr)))
  {
    perror("bind");
	exit (1);
  }

  if(listen (fd, 128))
  {
    perror("listen");
	exit (2);
  }

  if (!fork())
    setsid();
  else
    exit (0);

  len = sizeof(struct sockaddr);
  while ((fdc = accept (fd, (struct sockaddr *)&s_in, &len)))
  {
    l = get_random();
    write (fdc, file_entries[l%nombre], strlen(file_entries[l%nombre]));
    close (fdc);
  }

  return 0;
}
